Python 3.12.6 (tags/v3.12.6:a4a2d2b, Sep  6 2024, 20:11:23) [MSC v.1940 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license()" for more information.
from collections import deque, defaultdict

def bfs(start, max_distance, graph, protected):
    queue = deque([start])
    visited = {start}
    distance = 0
    
    while queue and distance < max_distance:
        for _ in range(len(queue)):
            current = queue.popleft()
            protected.add(current)

            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
...                     queue.append(neighbor)
...                     
...         distance += 1
... 
... def main():
...     import sys
...     input = sys.stdin.read
...     data = input().strip().splitlines()
...     
...     n, m, k = map(int, data[0].split())
...     
...     graph = defaultdict(list)
...     
...     # Чтение дорог
...     index = 1
...     for _ in range(m):
...         a, b = map(int, data[index].split())
...         graph[a].append(b)
...         graph[b].append(a)
...         index += 1
...     
...     protected = set()
...     
...     # Чтение охранников и выполнение BFS
...     for _ in range(k):
...         p, h = map(int, data[index].split())
...         bfs(p, h, graph, protected)
...         index += 1
...     
...     protected = sorted(protected)
...     
...     # Вывод результатов
...     print(len(protected))
...     if protected:
...         print(' '.join(map(str, protected)))
...     else:
...         print('')
... 
... if __name__ == "__main__":
