Python 3.12.6 (tags/v3.12.6:a4a2d2b, Sep  6 2024, 20:11:23) [MSC v.1940 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license()" for more information.
>>> import itertools
... 
... def calculate_distance(point1, point2):
...     return abs(point1[0] - point2[0]) + abs(point1[1] - point2[1])
... 
... def total_route_length(route):
...     length = 0
...     for i in range(len(route) - 1):
...         length += calculate_distance(route[i], route[i + 1])
...     return length
... 
... def main():
...     import sys
...     input = sys.stdin.read
...     data = input().strip().splitlines()
...     
...     n = int(data[0])
...     points = []
...     
...     for i in range(1, n + 1):
...         x, y = map(int, data[i].split())
...         points.append((x, y))
...     
...     min_length = float('inf')
...     
...     # Перебор всех возможных маршрутов
...     for perm in itertools.permutations(points):
...         length = total_route_length(perm)
...         min_length = min(min_length, length)
...     
...     print(f"{min_length:.9f}")
... 
... if __name__ == "__main__":
